<?php
/*
* SEF Advance extension for Virtuemart 1.1.4
* v1.3.7 2012-08-28
* Copyright (C) 2007-2011 Emir Sakic, http://www.sakic.net
*
* Based on:
* VirtueMart_Sef - open source sef_ext.php module.
* Copyright (C) 2006 Vlastimil Vaçek, virtuemart@joomy.net, http://www.joomy.net/virtuemart/
*
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

(defined( '_VALID_MOS' ) || defined( '_JEXEC' )) or die( 'Restricted access' );

/* configuration */

// strings
define('_VM_PRODUCT_LIST', 'product list');
define('_VM_SEARCH', 'search');
define('_VM_CART', 'cart');
define('_VM_ASK', 'ask');
define('_VM_ORDER_DETAILS', 'order details');
define('_VM_ACCOUNT_INDEX', 'index');
define('_VM_ACCOUNT_BILLING', 'billing');
define('_VM_ACCOUNT_SHIPPING', 'shipping');
define('_VM_ACCOUNT_SHIPTO', 'shipto');
define('_VM_CHECKOUT', 'checkout');

// use custom titles & metadata
$meta = 1;

$config_file = dirname(realpath (__FILE__)).'/../../administrator/components/com_virtuemart/virtuemart.cfg.php';
if (file_exists($config_file)) {
	// open the file
	$FILE = fread(fopen($config_file, "r"), filesize($config_file));
	// get the defines
	if (!defined('SEF_VM_TABLEPREFIX')) {
		sef_get_define('VM_TABLEPREFIX', $FILE);
	}
	if (!defined('SEF_SEARCH_ROWS')) {
		sef_get_define('SEARCH_ROWS', $FILE);
	}
	if (!defined('SEF_VM_BROWSE_ORDERBY_FIELD')) {
		sef_get_define('VM_BROWSE_ORDERBY_FIELD', $FILE);
	}
}

if (!defined('SEF_VM_TABLEPREFIX')) {
	define('SEF_VM_TABLEPREFIX', 'vm');
}
if (!defined('SEF_SEARCH_ROWS')) {
	define('SEF_SEARCH_ROWS', 30);
}
if (!defined('SEF_VM_BROWSE_ORDERBY_FIELD')) {
	define('SEF_VM_BROWSE_ORDERBY_FIELD', 'product_name');
}

/* end configuration */

class sef_virtuemart {

	function create($string){
		global $database;
		
		if (empty($database)) {
			// Joomla 1.5
			$database = &JFactory::getDbo();
		}
		
		// keep non-sef URL for complicated strings
		if (preg_match('/keyword=/i', $string)) {
			return str_replace('&amp;', '&', $string);
		}

		$sefstring = '';
		$string = str_replace( '&amp;', '&', $string );

		if (preg_match('/page=shop.browse/i',$string) && preg_match('/&category_id=/i',$string)) {
			//category
			$temp = split('&category_id=', $string);
			$temp = split('&', $temp[1]);
			if ($temp[0]==0) {
				$sefstring = sefencode(_VM_PRODUCT_LIST);
			} else {
				$sefstring = create_category_path($temp[0]);
			}

			// ----- handle sorting AND pagination
			$pagination = 0;
			$default_direction = 'ASC';
			$vmlimitstart = 0;
			$vmlimit = SEF_SEARCH_ROWS;
			$default_order = SEF_VM_BROWSE_ORDERBY_FIELD;
			// determine sort key
			$order = null;
			if (preg_match('/&orderby=/i',$string)) {
				$temp = split('&orderby=', $string);
				$temp = split('&', $temp[1]);
				if ($temp[0] != $default_order) {
					$order = $temp[0];
				}
			}
			// determine direction
			$direction = null;
			if (preg_match('/&DescOrderBy=/i',$string)) {
				$temp = split('&DescOrderBy=', $string);
				$temp = split('&', $temp[1]);
				if ($temp[0] != $default_direction) {
					$direction = $temp[0];
				}
			}
			// determine limit per page
			if (preg_match('/&DescOrderBy=/i',$string)) {
				$temp = split('&limit=', $string);
				$temp = split('&', $temp[1]);
				if ($temp[0] != '') {
					$vmlimit = $temp[0];
					$pagination = 1;
				}
			}
			// determine which document to start displaying from
			if (preg_match('/&DescOrderBy=/i',$string)) {
				$temp = split('&limitstart=', $string);
				$temp = split('&', $temp[1]);
				if ($temp[0]!='') {
					$vmlimitstart = $temp[0];
					$pagination = 1;
				}
			}
			// handle sorting
			if ( $order || $direction || $pagination) {
				$sefstring .= '---';
			}
			if ( $order || $direction ) {
				//add direction_order to sefstring
				if ($direction) {
					$sefstring .= $direction;
				}
				if ($direction && $order) {
					$sefstring .= '-';
				}
				if ($order) {
					$sefstring .= $order;
				}
			}
			//handle pagination
			if ($pagination) {
				if ($direction || $order) {
					$sefstring .= '-';
				}
				$sefstring .= 'start-'.$vmlimitstart.'-limit-'.$vmlimit;
			} else if (preg_match('/&limitstart=/i',$string)) {
				if (preg_match('/&limit=/i',$string)) {
					$temp = split('&limit=', $string);
					$temp = split('&', $temp[1]);
					$sefstring .= '/'.$temp[0];
				}
				// category pagination
				$temp = split('&limitstart=', $string);
				$temp = split('&', $temp[1]);
				if ($temp[0]!=0 || preg_match('/&limit=/i',$string)) {
					$sefstring .= '/'.$temp[0];
				}
			}

			$sefstring .= '/';

		} else if (preg_match('/&product_id=/i',$string) &&	(preg_match('/page=shop.product_details/i',$string) || preg_match('/page=shop.ask/i',$string))){	//products
			$temp = split('&product_id=', $string);
			$temp = split('&', $temp[1]);
			$pid = $temp[0];
			$database->setQuery( "SELECT product_name FROM #__".SEF_VM_TABLEPREFIX."_product WHERE product_id = '" . $pid . "'" );
			$prod = sefencode($database->loadResult());
			if (preg_match('/&category_id=/i',$string)) {
				$temp = split('&category_id=', $string);
				$temp = split('&', $temp[1]);
				$cid = $temp[0];
			} else {
				$query = "SELECT c.category_id "
					."FROM #__".SEF_VM_TABLEPREFIX."_category AS c "
					."LEFT JOIN #__".SEF_VM_TABLEPREFIX."_product_category_xref AS x ON x.category_id = c.category_id "
					."WHERE x.product_id= '". $pid . "'"
					;
				$database->setQuery( $query );
				$cid = $database->loadResult();
			}
			$cat = create_category_path($cid);
			$sefstring = $cat.'/'.$prod;
			$sefstring .= '/';
			if (preg_match('/page=shop.ask/i',$string)) {
				// cart
				$sefstring .= sefencode(_VM_ASK);
				$sefstring .= '/';
			}
		} else if (preg_match('/page=shop.browse/i',$string) && !preg_match('/&category_id=/i',$string) && !preg_match('/&product_id=/i',$string) && !preg_match('/&manufacturer_id=/i',$string)) {
			// list all products
			$sefstring .= sefencode(_VM_PRODUCT_LIST);
			$sefstring .= '/';
		} else if (preg_match('/page=shop.search/i',$string)) {
			// search
			$sefstring = sefencode(_VM_SEARCH);
			$sefstring .= '/';
		} else if (preg_match('/page=shop.cart/i',$string)) {
			// cart
			$sefstring = sefencode(_VM_CART);
			$sefstring .= '/';
		} else if (preg_match('/page=account.order_details/i',$string) && preg_match('/&order_id=/i',$string)) {
			// order details
			$sefstring .= sefencode(_VM_ORDER_DETAILS).'/';
			$temp = split('&order_id=', $string);
			$temp = split('&', $temp[1]);
			$order_id = $temp[0];
			$sefstring .= $order_id.'/';
		} else if (preg_match('/page=account.index/i',$string)) {
			// account index
			$sefstring .= sefencode(_VM_ACCOUNT_INDEX).'/';
		} else if (preg_match('/page=account.billing/i',$string)) {
			// account billing
			$sefstring .= sefencode(_VM_ACCOUNT_BILLING).'/';
		} else if (preg_match('/page=account.shipping/i',$string) && !preg_match('/next_page=account.shipping/i',$string)) {
			// account shipping
			$sefstring .= sefencode(_VM_ACCOUNT_SHIPPING).'/';
		} else if (preg_match('/page=account.shipto/i',$string)) {
			// account shipto
			$sefstring .= sefencode(_VM_ACCOUNT_SHIPTO).'/';
			if (preg_match('/next_page=account.shipping/i',$string)) {
				$sefstring .= sefencode(_VM_ACCOUNT_SHIPPING).'/';
			}
			if (preg_match('/&user_info_id=/i',$string)) {
				$temp = explode('&user_info_id=', $string);
				$temp = explode('&', $temp[1]);
				$user_info_id = $temp[0];
				$sefstring .= $user_info_id.'/';
			}
		} else if (preg_match('/page=checkout.index/i',$string)) {
			// checkout
			$temp = explode('page=checkout.index&', $string);
			if (isset($temp[1]) && strlen($temp[1])>80) {
				$sefstring .= '?page=checkout.index&'.$temp[1];
			} else {
				$sefstring .= sefencode(_VM_CHECKOUT).'/';
			}
			if (isset($temp[1]) && preg_match('/ssl_redirect=1/i',$temp[1])) {
				$sefstring .= 'ssl_redirect/';
			}
		} else if (preg_match('/Itemid=([0-9]+)$/i',$string,&$matches)) {
			$Itemid = $matches[1];
			// directly linked to menu?
			$menu	= &JSite::getMenu();
			$menuItem = &$menu->getItem($Itemid);
			$sefstring = $menuItem->alias.'/';
		} else {
			// all the rest
			$temp 		= split("\?", $string);
			$temp 		= split('&', $temp[1]);

			foreach($temp as $key => $value) {
				if (!preg_match('/option/i',$value) && !preg_match('/Itemid/i',$value)) {
					$sefstring .= $value.'/';
				}
			}
			$sefstring = str_replace( '=', ',', $sefstring );
		}

		if (preg_match('/&vmcchk=1/i',$string)) {
			$sefstring .= 'vmcchk/';
		}

		return $sefstring;

	}

	function revert($url_array, $pos){
		global $database, $meta;
		
		if (empty($database)) {
			// Joomla 1.5
			$database = &JFactory::getDbo();
		}

		// keep non-sef URL for complicated strings
		if (preg_match('/index.php?/i', $_SERVER['REQUEST_URI'])) {
			return;
		}
		
		// custom titles & metadata
		if ($meta==1) {
			$q = "SELECT vendor_name FROM #__".SEF_VM_TABLEPREFIX."_vendor LIMIT 1";
			$database->setQuery( $q );
			if ( $vendor_name = $database->loadResult() ) {
				$GLOBALS['mosConfig_pagetitles'] = '0';
				$GLOBALS['mosConfig_sitename'] = $vendor_name;
			}
		}

		$nonsefstring = '';
		
		if (empty($url_array[$pos+3])) {
			// /virtuemart/menu-alias/
			// check if linked to menu directly
			
			$alias = $url_array[$pos+2];
			
			$q = "SELECT id FROM #__menu WHERE type='component' AND alias='$alias' LIMIT 1";
			$database->setQuery( $q );
			if ($Itemid = $database->loadResult()) {
				$_GET['Itemid'] = $_REQUEST['Itemid'] = $Itemid;
				return '&Itemid='.$Itemid;
			}
		}

		if (in_array('vmcchk', $url_array)) {
			$vmcchk = 1;
			$_GET['vmcchk'] = $_REQUEST['vmcchk'] = $vmcchk;
			$nonsefstring .= '&vmcchk=1';
			array_pop($url_array);
			$url_array[count($url_array)-1] = '';
		}

		if ($url_array[count($url_array)-2]==_VM_ASK) {
			$product_name = sefdecode($url_array[count($url_array)-3]);
		} else {
			$product_name = sefdecode($url_array[count($url_array)-2]);
		}
		
		$q = "SELECT product_id FROM #__".SEF_VM_TABLEPREFIX."_product WHERE product_name='$product_name' LIMIT 1";
		$database->setQuery( $q );

		if (isset($url_array[$pos+2]) && $url_array[$pos+2]==sefencode(_VM_SEARCH)) {
			$page = $_GET['page'] = $_REQUEST['page'] = 'shop.search';
			$nonsefstring .= 'page=' . $page;
		} else if (isset($url_array[$pos+2]) && $url_array[$pos+2]==sefencode(_VM_CART)) {
			$page = $_GET['page'] = $_REQUEST['page'] = 'shop.cart';
			$nonsefstring .= 'page=' . $page;
		} else if (isset($url_array[$pos+2]) && $url_array[$pos+2]==sefencode(_VM_ORDER_DETAILS)) {
			$page = $_GET['page'] = $_REQUEST['page'] = 'account.order_details';
			$nonsefstring .= '&page=' . $page;
			if (isset($url_array[$pos+3]) && $url_array[$pos+3]!='') {
				$order_id = $_GET['order_id'] = $_REQUEST['order_id'] = $url_array[$pos+3];
				$nonsefstring .= '&order_id=' . $order_id;
			}
		} else if (isset($url_array[$pos+2]) && $url_array[$pos+2]==sefencode(_VM_ACCOUNT_INDEX)) {
			$page = $_GET['page'] = $_REQUEST['page'] = 'account.index';
			$nonsefstring .= '&page=' . $page;
		} else if (isset($url_array[$pos+2]) && $url_array[$pos+2]==sefencode(_VM_ACCOUNT_BILLING)) {
			$page = $_GET['page'] = $_REQUEST['page'] = 'account.billing';
			$nonsefstring .= '&page=' . $page;
		} else if (isset($url_array[$pos+2]) && $url_array[$pos+2]==sefencode(_VM_ACCOUNT_SHIPPING)) {
			$page = $_GET['page'] = $_REQUEST['page'] = 'account.shipping';
			$nonsefstring .= '&page=' . $page;
		} else if (isset($url_array[$pos+2]) && $url_array[$pos+2]==sefencode(_VM_ACCOUNT_SHIPTO)) {
			$page = $_GET['page'] = $_REQUEST['page'] = 'account.shipto';
			$nonsefstring .= '&page=' . $page;
			if (isset($url_array[$pos+3]) && $url_array[$pos+3]==sefencode(_VM_ACCOUNT_SHIPPING)) {
				$next_page = $_GET['next_page'] = $_REQUEST['next_page'] = 'account.shipping';
				$nonsefstring .= '&next_page=' . $next_page;
				if (isset($url_array[$pos+4]) && $url_array[$pos+4]!='') {
					$user_info_id = $_GET['user_info_id'] = $_REQUEST['user_info_id'] = $url_array[$pos+4];
					$nonsefstring .= '&user_info_id=' . $user_info_id;
				}
			} else if (isset($url_array[$pos+3]) && $url_array[$pos+3]!='') {
				$next_page = $_GET['next_page'] = $_REQUEST['next_page'] = 'checkout.index';
				$nonsefstring .= '&next_page=' . $next_page;
				$user_info_id = $_GET['user_info_id'] = $_REQUEST['user_info_id'] = $url_array[$pos+3];
				$nonsefstring .= '&user_info_id=' . $user_info_id;
			}
		} else if (isset($url_array[$pos+2]) && $url_array[$pos+2]==sefencode(_VM_CHECKOUT)) {
			//|| isset($_GET['page']) && $_GET['page']=='checkout.index'
			$page = $_GET['page'] = $_REQUEST['page'] = 'checkout.index';
			$nonsefstring .= '&page=' . $page;
			if (isset($url_array[$pos+3]) && $url_array[$pos+3]=='ssl_redirect') {
				$ssl_redirect = $_GET['ssl_redirect'] = $_REQUEST['ssl_redirect'] = 1;
				$nonsefstring .= '&ssl_redirect=' . $ssl_redirect;
			}
		// --- Product pages-------------
		} else if ($pg_id = $database->loadResult()) {
			$q	= "SELECT p.product_id, c.category_id, c.category_flypage ";
			$q .= "FROM #__".SEF_VM_TABLEPREFIX."_product AS p ";
			$q .= "INNER JOIN #__".SEF_VM_TABLEPREFIX."_product_category_xref AS x ";
			$q .= "ON p.product_id = x.product_id ";
			$q .= "INNER JOIN #__".SEF_VM_TABLEPREFIX."_category AS c ";
			$q .= "ON c.category_id = x.category_id ";
			$q .= "WHERE p.product_id = $pg_id";

			$database->setQuery($q);

			$row = null;
			//$database->loadObject($row);
			$rows = $database->loadObjectList();
			$row = $rows[0];
			if ($row) {
				if ($url_array[count($url_array)-2]==_VM_ASK) {
					$page = $_GET['page'] = $_REQUEST['page'] = 'shop.ask';
				} else {
					$page = $_GET['page'] = $_REQUEST['page'] = 'shop.product_details';
				}
				$flypage = $_GET['flypage'] = $_REQUEST['flypage'] = $row->category_flypage ? $row->category_flypage : 'shop.flypage';
				$product_id = $_GET['product_id'] = $_REQUEST['product_id'] = $row->product_id;
				$category_id = $_GET['category_id'] = $_REQUEST['category_id'] = $row->category_id;
				$manufacturer_id = 0;
				$nonsefstring .= '&page=' . $page . '&flypage=' . $flypage . '&product_id=' . $product_id . '&category_id=' . $category_id . '&manufacturer_id=' . $manufacturer_id;
			} else {
				$q	= "SELECT product_parent_id FROM #__".SEF_VM_TABLEPREFIX."_product WHERE product_id = $pg_id";
				$database->setQuery($q);
				//$database->loadObject($row);
				$rows = $database->loadObjectList();
				$row = $rows[0];
				$parent = $row->product_parent_id;

				$q	= "SELECT p.product_id, c.category_id, c.category_flypage ";
				$q .= "FROM #__".SEF_VM_TABLEPREFIX."_product AS p ";
				$q .= "INNER JOIN #__".SEF_VM_TABLEPREFIX."_product_category_xref AS x ";
				$q .= "ON p.product_id = x.product_id ";
				$q .= "INNER JOIN #__".SEF_VM_TABLEPREFIX."_category AS c ";
				$q .= "ON c.category_id = x.category_id ";
				$q .= "WHERE p.product_id = $parent";

				$database->setQuery($q);
				
				$row = null;
				//$database->loadObject($row);
				$rows = $database->loadObjectList();
				$row = $rows[0];
				if ($row) {
					$page = $_GET['page'] = $_REQUEST['page'] = 'shop.product_details';
					$flypage = $_GET['flypage'] = $_REQUEST['flypage'] = $row->category_flypage ? $row->category_flypage : 'shop.flypage';
					$product_id = $_GET['product_id'] = $_REQUEST['product_id'] = $row->product_id;
					$category_id = $_GET['category_id'] = $_REQUEST['category_id'] = $row->category_id;
					$manufacturer_id = 0;
					$nonsefstring .= '&page=' . $page . '&flypage=' . $flypage . '&product_id=' . $product_id . '&category_id=' . $category_id . '&manufacturer_id=' . $manufacturer_id;
				}
			}

			if ($meta==1 && !empty($product_id)) {
				$q = "SELECT product_name, product_desc FROM #__".SEF_VM_TABLEPREFIX."_product WHERE product_id='$product_id'";
				$database->setQuery( $q );
				$row = null;
				//$database->loadObject($row);
				$rows = $database->loadObjectList();
				$row = $rows[0];
				if ( $row ) {
					$GLOBALS['mosConfig_sitename'] = $row->product_name . ' - ' . $GLOBALS['mosConfig_sitename'];
					$GLOBALS['mosConfig_MetaDesc'] = $row->product_name; //substr(strip_tags($row->product_desc),0,255);
				}
			}

		} else {
			// Pagination
			if ( is_numeric($url_array[count($url_array)-2]) ) {
				$limitstart = $url_array[count($url_array)-2];
				$_GET['limitstart'] = $_REQUEST['limitstart'] = $limitstart;
				// remove page number from array
				array_splice($url_array, -2, 1);
				if ( is_numeric($url_array[count($url_array)-2]) ) {
					// $limit/$limitstart/
					$limit = $url_array[count($url_array)-2];
					$_GET['limit'] = $_REQUEST['limit'] = $limit;
					// remove page number from array
					array_splice($url_array, -2, 1);
				}
			} else if ( empty($_REQUEST['limitstart']) ) {
				// reset
				$_GET['limitstart'] = $_REQUEST['limitstart'] = 0;
			}
			// --- Category and list all products -------------
			if (isset($url_array[$pos+2]) && $url_array[$pos+2]!='' && !preg_match('/,/i', $url_array[$pos+2])) {
				$category = $url_array[count($url_array)-2];
				$tempstring = '';
				if (preg_match('/---/i',$category)) {
					// pagination or sorting
					$temp = split("---", $category);
					$category = $temp[0];
					$temp = split("-", $temp[1]);
					$DescOrderBy = "ASC"; $limitstart = 0;
					$limit = SEF_SEARCH_ROWS;
					$orderby = SEF_VM_BROWSE_ORDERBY_FIELD;
					if( in_array( 'product_name', $temp))	$orderby = 'product_name';
					if( in_array( 'product_sku', $temp))	$orderby = 'product_sku';
					if( in_array( 'product_price', $temp))	$orderby = 'product_price';
					if( in_array( 'product_cdate', $temp))	$orderby = 'product_cdate';
					if( in_array( 'ASC', $temp))	$DescOrderBy = 'ASC';
					if( in_array( 'DESC', $temp))	$DescOrderBy = 'DESC';
					if( in_array( 'start', $temp)) $limitstart = $temp[array_search('start', $temp)+1];
					if( in_array( 'limit', $temp)) $limit = $temp[array_search('limit', $temp)+1];
					$_GET['orderby'] = $_REQUEST['orderby'] = $orderby;
					$tempstring .= '&orderby=$orderby';
					$_GET['DescOrderBy'] = $_REQUEST['DescOrderBy'] = $DescOrderBy;
					$tempstring .= '&DescOrderBy=$DescOrderBy';
					$_GET['limit'] = $_REQUEST['limit'] = $limit;
					$tempstring .= '&limit=$limit';
					$_GET['limitstart'] = $_REQUEST['limitstart'] = $limitstart;
					$tempstring .= '&limitstart=$limitstart';
				}
				if ($category == sefencode(_VM_PRODUCT_LIST)) {
					// list all products ???
					$catid = 0;
				} else {
					$cat_array = array_slice ($url_array, 2, -2);
					array_push ($cat_array, $category);
					$catid = revert_category_path($cat_array);
				}
				$nonsefstring = $nonsefstring . '&page=shop.browse&category_id=' . $catid;
				$page = $_GET['page'] = $_REQUEST['page'] = 'shop.browse';
				$category_id = $_GET['category_id'] = $_REQUEST['category_id'] = $catid;

				$nonsefstring .= $tempstring;

				if ($meta==1 && !empty($catid)) {
					$q = "SELECT category_name FROM #__".SEF_VM_TABLEPREFIX."_category WHERE category_id='$category_id'";
					$database->setQuery( $q );
					if ( $category_name = $database->loadResult() ) {
						$GLOBALS['mosConfig_sitename'] = $category_name . ' - ' . $GLOBALS['mosConfig_sitename'];
						$GLOBALS['mosConfig_MetaDesc'] = $category_name;
					}
				}

			// --- All the rest -------------
			} else {
				foreach($url_array as $value) {
					$temp = explode(',', $value);
					if (isset($temp[0]) && $temp[0]!='' && isset($temp[1]) && $temp[1]!='') {
						$_GET[$temp[0]] = $_REQUEST[$temp[0]] = $temp[1];
						$nonsefstring .= "&$temp[0]=$temp[1]";
					}
				}
			}

		}

		return $nonsefstring;

	} // end function revert

} // end class

function create_category_path($category_id) {
	global $database;
	
	if (empty($database)) {
		// Joomla 1.5
		$database = &JFactory::getDbo();
	}

	$vmsefpath = '';
	do {
		$q = "SELECT category_id, category_name,category_parent_id FROM #__".SEF_VM_TABLEPREFIX."_category, #__".SEF_VM_TABLEPREFIX."_category_xref WHERE ";
		$q .= "#__".SEF_VM_TABLEPREFIX."_category_xref.category_child_id='$category_id' ";
		$q .= "AND #__".SEF_VM_TABLEPREFIX."_category.category_id='$category_id'";
		$database->setQuery($q);
		$row = null;
		//$database->loadObject($row);
		$rows = $database->loadObjectList();
		$row = $rows[0];
		if ($row->category_parent_id) {
			$link = sefencode($row->category_name);
			$vmsefpath = '/'. $link. $vmsefpath;
		} else {
			$link = sefencode($row->category_name);
			$vmsefpath = $link . $vmsefpath;
		}
		$category_id = $row->category_parent_id;
	} while ($row->category_parent_id<>0);

	return $vmsefpath;
}

function revert_category_path($cat_array) {
	global $database;
	
	if (empty($database)) {
		// Joomla 1.5
		$database = &JFactory::getDbo();
	}

	$catid = 0;
	$q = "SELECT c.category_id, c.category_name, x.category_parent_id ";
	$q .= "FROM #__".SEF_VM_TABLEPREFIX."_category AS c ";
	$q .= "INNER JOIN #__".SEF_VM_TABLEPREFIX."_category_xref AS x ";
	$q .= "ON c.category_id = x.category_child_id";
	$database->setQuery($q);
	$rows = $database->loadObjectList();
	foreach ($rows as $r) {
		$cats[sefencode($r->category_name)][$r->category_parent_id] = $r->category_id;
	}
	$parent = 0;
	for ($i = 0; $i < count($cat_array); $i++) {
		$category = $cat_array[$i];
		$catid = array_searchMultiOnKeys($cats, array($category, $parent));
		$parent = $catid;
	}
	return $catid;
}

function array_searchMultiOnKeys($multiArray, $searchKeysArray) {
	foreach ($searchKeysArray as $keySearch) {
		$multiArray = isset($multiArray[$keySearch]) ? $multiArray[$keySearch] : '';
		$result = $multiArray;
	}
	if (is_array($multiArray)) {
		$result = true;
	} else if ($result == '') {
		$result = false;
	}
	return $result;
}

function sef_get_define($defname, $FILE) {
	if ( preg_match("/define\(\s?\'$defname\',\s?\'(.*?)\'/", $FILE, $matches) ) {
		define('SEF_'.$defname, $matches[1] );
	}
}
?>
